import DOMPointReadOnly from './DOMPointReadOnly.cjs';
/**
 * DOM Point.
 *
 * @see https://developer.mozilla.org/en-US/docs/Web/API/DOMPoint
 */
export default class DOMPoint extends DOMPointReadOnly {
    /**
     * Sets x.
     *
     * @param value X.
     */
    set x(value: number);
    /**
     * Returns x.
     *
     * @returns X.
     */
    get x(): number;
    /**
     * Sets y.
     *
     * @param value Y.
     */
    set y(value: number);
    /**
     * Returns y.
     *
     * @returns Y.
     */
    get y(): number;
    /**
     * Sets z.
     *
     * @param value Z.
     */
    set z(value: number);
    /**
     * Returns z.
     *
     * @returns Z.
     */
    get z(): number;
    /**
     * Sets w.
     *
     * @param value W.
     */
    set w(value: number);
    /**
     * Returns w.
     *
     * @returns W.
     */
    get w(): number;
}
//# sourceMappingURL=DOMPoint.d.ts.map