import HTMLElement from '../html-element/HTMLElement.js';
/**
 * HTMLModElement
 *
 * @see https://developer.mozilla.org/en-US/docs/Web/API/HTMLModElement
 */
export default class HTMLModElement extends HTMLElement {
    /**
     * Returns source.
     *
     * @returns Source.
     */
    get cite(): string;
    /**
     * Sets source.
     *
     * @param cite Source.
     */
    set cite(cite: string);
    /**
     * Returns date time.
     *
     * @returns Date time.
     */
    get dateTime(): string;
    /**
     * Sets date time.
     *
     * @param dateTime Date time.
     */
    set dateTime(dateTime: string);
}
//# sourceMappingURL=HTMLModElement.d.ts.map